VERSION 5.00
Begin VB.Form frmLCD 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4965
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5070
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4965
   ScaleWidth      =   5070
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox LCDb 
      Height          =   855
      Left            =   360
      ScaleHeight     =   795
      ScaleWidth      =   2475
      TabIndex        =   1
      Top             =   1920
      Width           =   2535
   End
   Begin VB.Timer Timer1 
      Left            =   4320
      Top             =   240
   End
   Begin VB.PictureBox LCD 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      FillColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "MS PGothic"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   645
      Left            =   120
      ScaleHeight     =   43
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   160
      TabIndex        =   0
      Top             =   240
      Width           =   2400
   End
End
Attribute VB_Name = "frmLCD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


' Copyright  2011 Dan Minut, http://www.mangareader.com
' =======================================================
' A quick note about the LCD picturebox:

' To make things easier to deal with, set scalemode to pixels on the form and
' the picturebox, then set the size to match the LCD (ie, 160x43 or 320x240).

' AutoRedraw should be set to true.  For monochrome, make sure to set the font to
' a bitmap font.  The Terminal font works pretty well.  For color, TrueType fonts
' look much better.

' A quick note about memory.  It seems that while running the program in the VB IDE,
' the program will leak memory.  If you build an EXE and run that, the memory leak
' disappears.  Not sure what the IDE is doing, but I'm guessing it's a problem with
' VB6's debugging routines.  It shouldn't be a huge issue, but you'll probably want
' to close and reopen the IDE periodically instead of leaving it open for days at
' a time.


Dim connection As Long
Dim device As Long
Dim deviceType As Long
Dim cnt As Integer
Dim direction As Boolean




Private Sub Form_Load()
    
    LCDEnabled = False
    
    'Call fucntion from Module to connect to LCD.
    deviceType = LCDOpen("My VB6 Example", connection, device)
    If deviceType = LGLCD_DEVICE_BW Or deviceType = LGLCD_DEVICE_QVGA Then
        LCDEnabled = True
    End If
    
    
        
    If LCDEnabled Then
        If deviceType = LGLCD_DEVICE_BW Then
            
            LCD.Width = frmLCD.ScaleX(160, vbPixels, frmLCD.ScaleMode)
            LCD.Height = frmLCD.ScaleY(43, vbPixels, frmLCD.ScaleMode)
            LCD.FontName = "Terminal"
            LCD.FontSize = 8
            
            LCD.Cls
            LcdUpdateBitmap device, LCD.Image, LGLCD_DEVICE_BW
        Else
            LCD.Width = frmLCD.ScaleX(320, vbPixels, frmLCD.ScaleMode)
            LCD.Height = frmLCD.ScaleY(240, vbPixels, frmLCD.ScaleMode)
            LCD.FontName = "Arial"
            LCD.FontSize = 14
            
            LCD.Cls
            LcdUpdateBitmap device, LCD.Image, LGLCD_DEVICE_QVGA
        End If
        'Doesn't do anything until after the first LcdUpdateBitmap.
        LcdSetAsLCDForegroundApp device, LGLCD_FORE_YES
        
        'Set the button callback address to our subroutine in the Module.
        'LcdSetButtonCallback AddressOf softButtonHandler
        
        LcdSetConfigCallback AddressOf configurationHandler
        
        'Because we shouldn't do much in the callback, do our button processing in a timer.
        'keep interval relatively long.  100ms is probably more appropriate.  At 10ms, if someone
        'really hammers the LCD buttons, it'll lock up the program.
        Timer1.Interval = 50
        Timer1.Enabled = True
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Close down device, connection and library.
    Timer1.Enabled = False
    
    LcdClose device
    LcdDisconnect connection
    LcdDeInit
    Unload frmConfigure
    
End Sub

Private Sub Timer1_Timer()
    Dim hBmp As Long
    
    'Check to see if the user is requesting our configuration screen.
    If ConfigureFlag > 0 Then
        frmConfigure.Show
        ConfigureFlag = 0
    End If
    
    'Only update screen if configuration isn't visible.
    If Not frmConfigure.Visible Then
    
        LCDButtons = LcdReadSoftButtons(device)
        LCD.Cls
        
        LCD.Print ("This is a test")
        LCD.CurrentY = LCD.FontSize + 4
        LCD.Print ("Line 2")
        LCD.CurrentY = (LCD.FontSize + 4) * 3
        LCD.Print (String$(cnt, "="))
        
        If (LCDButtons And LGLCD_BUTTON_1) = LGLCD_BUTTON_1 Then
            drawNumberedCircle LCD, 15, 26, 5, "1", vbBlack
        End If
        If (LCDButtons And LGLCD_BUTTON_2) = LGLCD_BUTTON_2 Then
            drawNumberedCircle LCD, 55, 26, 5, "2", vbBlack
        End If
        If (LCDButtons And LGLCD_BUTTON_3) = LGLCD_BUTTON_3 Then
            drawNumberedCircle LCD, 98, 26, 5, "3", vbBlack
        End If
        If (LCDButtons And LGLCD_BUTTON_4) = LGLCD_BUTTON_4 Then
            drawNumberedCircle LCD, 140, 26, 5, "4", vbBlack
        End If
        
        If (LCDButtons And LGLCD_BUTTON_LEFT) = LGLCD_BUTTON_LEFT Then
            drawNumberedCircle LCD, 60, 160, 15, "L", vbBlack
        End If
        If (LCDButtons And LGLCD_BUTTON_RIGHT) = LGLCD_BUTTON_RIGHT Then
            drawNumberedCircle LCD, 180, 160, 15, "R", vbBlack
        End If
        If (LCDButtons And LGLCD_BUTTON_UP) = LGLCD_BUTTON_UP Then
            drawNumberedCircle LCD, 120, 100, 15, "U", vbBlack
        End If
        If (LCDButtons And LGLCD_BUTTON_DOWN) = LGLCD_BUTTON_DOWN Then
            drawNumberedCircle LCD, 120, 220, 15, "D", vbBlack
        End If
        
        If (LCDButtons And LGLCD_BUTTON_MENU) = LGLCD_BUTTON_MENU Then
            drawNumberedCircle LCD, 60, 220, 15, "M", vbBlue
        End If
        If (LCDButtons And LGLCD_BUTTON_CANCEL) = LGLCD_BUTTON_CANCEL Then
            drawNumberedCircle LCD, 180, 220, 15, "<=", vbRed
        End If
        If (LCDButtons And LGLCD_BUTTON_OK) = LGLCD_BUTTON_OK Then
            drawNumberedCircle LCD, 120, 160, 15, "OK", vbGreen
        End If
        
        If Not direction Then
            cnt = cnt + 1
            If cnt > 25 Then
                cnt = 25
                direction = Not direction
            End If
        Else
            cnt = cnt - 1
            If cnt < 1 Then
                cnt = 1
                direction = Not direction
            End If
        End If
        

        
        'This only updates the monochrome image.  Doing the same for the color display is pretty similar.
        If deviceType = LGLCD_DEVICE_BW Then
            LcdUpdateBitmap device, LCD.Image, LGLCD_DEVICE_BW
        Else
            LcdUpdateBitmap device, LCD.Image, LGLCD_DEVICE_QVGA
        End If
    End If
End Sub
